
#line 1 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
#include <assert.h>
#include <ruby.h>

#if defined(_WIN32)
#include <stddef.h>
#endif

#ifdef HAVE_RUBY_RE_H
#include <ruby/re.h>
#else
#include <re.h>
#endif

#ifdef HAVE_RUBY_ENCODING_H
#include <ruby/encoding.h>
#define ENCODED_STR_NEW(ptr, len) \
    rb_enc_str_new(ptr, len, rb_utf8_encoding())
#else
#define ENCODED_STR_NEW(ptr, len) \
    rb_str_new(ptr, len)
#endif

#ifndef RSTRING_PTR
#define RSTRING_PTR(s) (RSTRING(s)->ptr)
#endif

#ifndef RSTRING_LEN
#define RSTRING_LEN(s) (RSTRING(s)->len)
#endif

#define DATA_GET(FROM, TYPE, NAME) \
  Data_Get_Struct(FROM, TYPE, NAME); \
  if (NAME == NULL) { \
    rb_raise(rb_eArgError, "NULL found for " # NAME " when it shouldn't be."); \
  }
 
typedef struct lexer_state {
  int content_len;
  int line_number;
  int current_line;
  int start_col;
  size_t mark;
  size_t keyword_start;
  size_t keyword_end;
  size_t next_keyword_start;
  size_t content_start;
  size_t content_end;
  size_t docstring_content_type_start;
  size_t docstring_content_type_end;
  size_t query_start;
  size_t last_newline;
  size_t final_newline;
} lexer_state;

static VALUE mGherkin;
static VALUE mGherkinLexer;
static VALUE mCLexer;
static VALUE cI18nLexer;
static VALUE rb_eGherkinLexingError;

#define LEN(AT, P) (P - data - lexer->AT)
#define MARK(M, P) (lexer->M = (P) - data)
#define PTR_TO(P) (data + lexer->P)

#define STORE_KW_END_CON(EVENT) \
  store_multiline_kw_con(listener, # EVENT, \
    PTR_TO(keyword_start), LEN(keyword_start, PTR_TO(keyword_end - 1)), \
    PTR_TO(content_start), LEN(content_start, PTR_TO(content_end)), \
    lexer->current_line, lexer->start_col); \
    if (lexer->content_end != 0) { \
      p = PTR_TO(content_end - 1); \
    } \
    lexer->content_end = 0

#define STORE_ATTR(ATTR) \
    store_attr(listener, # ATTR, \
      PTR_TO(content_start), LEN(content_start, p), \
      lexer->line_number)


#line 254 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"


/** Data **/

#line 89 "ext/gherkin_lexer_sr_cyrl/gherkin_lexer_sr_cyrl.c"
static const char _lexer_actions[] = {
	0, 1, 0, 1, 1, 1, 2, 1, 
	3, 1, 4, 1, 5, 1, 6, 1, 
	7, 1, 8, 1, 9, 1, 10, 1, 
	11, 1, 12, 1, 13, 1, 16, 1, 
	17, 1, 18, 1, 19, 1, 20, 1, 
	21, 1, 22, 1, 23, 2, 1, 18, 
	2, 4, 5, 2, 13, 0, 2, 14, 
	15, 2, 17, 0, 2, 17, 2, 2, 
	17, 16, 2, 17, 19, 2, 18, 6, 
	2, 18, 7, 2, 18, 8, 2, 18, 
	9, 2, 18, 10, 2, 18, 16, 2, 
	20, 21, 2, 22, 0, 2, 22, 2, 
	2, 22, 16, 2, 22, 19, 3, 3, 
	14, 15, 3, 5, 14, 15, 3, 11, 
	14, 15, 3, 12, 14, 15, 3, 13, 
	14, 15, 3, 14, 15, 18, 3, 17, 
	14, 15, 4, 1, 14, 15, 18, 4, 
	4, 5, 14, 15, 4, 17, 0, 14, 
	15
};

static const short _lexer_key_offsets[] = {
	0, 0, 12, 21, 22, 23, 24, 25, 
	26, 27, 29, 40, 41, 42, 44, 46, 
	51, 56, 61, 66, 70, 74, 76, 77, 
	78, 79, 80, 81, 82, 83, 84, 85, 
	86, 87, 88, 89, 90, 91, 96, 103, 
	108, 112, 118, 121, 123, 129, 140, 141, 
	142, 143, 144, 145, 146, 147, 148, 149, 
	152, 153, 155, 156, 157, 159, 160, 161, 
	162, 163, 165, 166, 167, 168, 169, 170, 
	171, 172, 173, 174, 175, 176, 185, 195, 
	197, 199, 201, 203, 205, 216, 218, 220, 
	222, 224, 226, 228, 230, 232, 234, 238, 
	240, 243, 245, 247, 250, 252, 254, 256, 
	258, 260, 262, 264, 266, 268, 270, 272, 
	274, 276, 278, 280, 282, 284, 286, 288, 
	290, 292, 294, 296, 298, 300, 302, 305, 
	307, 309, 311, 313, 315, 317, 319, 321, 
	323, 325, 327, 329, 331, 333, 335, 337, 
	339, 341, 343, 345, 347, 349, 351, 353, 
	355, 358, 360, 362, 364, 366, 368, 371, 
	373, 375, 377, 379, 381, 383, 385, 387, 
	389, 391, 393, 395, 397, 399, 401, 403, 
	405, 407, 409, 411, 413, 415, 417, 419, 
	421, 423, 425, 427, 429, 431, 433, 435, 
	437, 439, 441, 443, 445, 447, 449, 451, 
	453, 455, 457, 459, 461, 463, 465, 467, 
	469, 471, 473, 475, 477, 479, 481, 483, 
	485, 487, 489, 491, 493, 495, 497, 499, 
	501, 503, 505, 507, 509, 511, 513, 515, 
	517, 519, 521, 522, 523, 524, 525, 526, 
	527, 528, 529, 530, 539, 549, 551, 553, 
	555, 557, 559, 561, 563, 565, 567, 569, 
	571, 573, 575, 577, 581, 583, 585, 587, 
	589, 592, 594, 596, 598, 600, 602, 604, 
	606, 608, 610, 612, 614, 616, 618, 620, 
	622, 624, 626, 628, 631, 633, 635, 637, 
	639, 641, 643, 645, 647, 649, 651, 653, 
	655, 657, 659, 661, 663, 665, 667, 669, 
	671, 673, 675, 677, 679, 681, 683, 685, 
	687, 689, 691, 693, 695, 697, 699, 701, 
	703, 705, 707, 709, 711, 713, 715, 717, 
	719, 721, 723, 725, 727, 729, 731, 733, 
	735, 737, 739, 741, 743, 745, 747, 749, 
	751, 753, 755, 757, 759, 761, 763, 765, 
	767, 769, 771, 773, 774, 775, 776, 777, 
	778, 779, 780, 781, 782, 783, 784, 785, 
	786, 787, 788, 789, 790, 791, 792, 800, 
	807, 809, 811, 813, 815, 817, 820, 822, 
	824, 826, 828, 830, 832, 834, 836, 838, 
	840, 842, 844, 846, 848, 850, 852, 854, 
	856, 858, 860, 862, 864, 866, 868, 870, 
	872, 874, 876, 879, 881, 883, 885, 887, 
	889, 891, 893, 895, 897, 899, 901, 903, 
	906, 908, 910, 912, 914, 916, 918, 920, 
	922, 924, 926, 928, 930, 932, 934, 936, 
	938, 941, 943, 946, 948, 950, 952, 954, 
	956, 959, 961, 963, 965, 967, 969, 971, 
	973, 975, 977, 979, 981, 983, 985, 987, 
	989, 991, 993, 995, 997, 999, 1001, 1003, 
	1005, 1007, 1009, 1011, 1013, 1015, 1017, 1019, 
	1021, 1023, 1025, 1027, 1029, 1031, 1033, 1035, 
	1037, 1039, 1041, 1044, 1046, 1048, 1050, 1052, 
	1054, 1056, 1058, 1060, 1062, 1064, 1066, 1068, 
	1070, 1072, 1074, 1076, 1078, 1080, 1082, 1084, 
	1086, 1088, 1090, 1092, 1094, 1096, 1098, 1100, 
	1102, 1104, 1106, 1108, 1110, 1112, 1114, 1116, 
	1117, 1118, 1119, 1120, 1121, 1122, 1124, 1125, 
	1126, 1127, 1128, 1129, 1130, 1131, 1132, 1133, 
	1134, 1135, 1136, 1137, 1138, 1140, 1141, 1142, 
	1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 
	1151, 1152, 1153, 1154, 1155, 1156, 1157, 1158, 
	1159, 1160, 1162, 1163, 1164, 1165, 1166, 1173, 
	1177, 1179, 1181, 1183, 1185, 1187, 1189, 1191, 
	1193, 1195, 1197, 1199, 1201, 1203, 1205, 1207, 
	1209, 1211, 1213, 1215, 1217, 1219, 1221, 1223, 
	1225, 1227, 1229, 1231, 1233, 1235, 1237, 1239, 
	1241, 1243, 1245, 1247, 1249, 1251, 1253, 1255, 
	1257, 1259, 1261, 1263, 1265, 1267, 1269, 1271, 
	1272, 1273, 1282, 1292, 1294, 1296, 1298, 1300, 
	1302, 1304, 1306, 1308, 1310, 1312, 1314, 1316, 
	1318, 1320, 1324, 1326, 1329, 1331, 1333, 1336, 
	1338, 1340, 1342, 1344, 1347, 1349, 1351, 1353, 
	1355, 1357, 1359, 1361, 1363, 1365, 1367, 1369, 
	1371, 1373, 1375, 1377, 1379, 1381, 1383, 1385, 
	1387, 1389, 1391, 1393, 1395, 1397, 1400, 1402, 
	1404, 1406, 1408, 1410, 1412, 1415, 1417, 1419, 
	1421, 1423, 1425, 1427, 1429, 1431, 1433, 1435, 
	1437, 1439, 1442, 1444, 1446, 1448, 1450, 1452, 
	1454, 1456, 1458, 1460, 1462, 1464, 1466, 1468, 
	1470, 1472, 1474, 1477, 1479, 1481, 1483, 1485, 
	1487, 1490, 1492, 1494, 1496, 1498, 1500, 1502, 
	1504, 1506, 1508, 1510, 1512, 1514, 1516, 1518, 
	1520, 1522, 1524, 1526, 1528, 1530, 1532, 1534, 
	1536, 1538, 1540, 1542, 1544, 1546, 1548, 1550, 
	1552, 1554, 1556, 1558, 1560, 1562, 1564, 1566, 
	1568, 1570, 1572, 1574, 1576, 1578, 1580, 1582, 
	1584, 1586, 1588, 1590, 1592, 1594, 1596, 1598, 
	1600, 1602, 1604, 1606, 1608, 1610, 1612, 1614, 
	1616, 1618, 1620, 1622, 1624, 1626, 1628, 1630, 
	1632, 1634, 1636, 1638, 1640, 1642, 1643, 1644, 
	1645, 1646, 1647, 1648, 1649, 1651, 1652, 1653, 
	1654, 1655, 1656, 1657, 1658, 1659, 1660, 1661, 
	1662, 1663, 1664, 1665, 1666, 1667, 1668, 1669, 
	1670, 1671, 1672, 1673, 1674, 1675, 1676, 1677, 
	1678, 1679, 1680, 1681, 1682, 1683, 1684, 1685, 
	1686, 1687, 1688, 1689, 1690, 1691, 1692, 1694, 
	1695, 1696, 1697, 1698, 1699, 1700, 1701, 1702, 
	1703, 1704, 1705, 1706, 1707, 1708, 1709, 1710, 
	1711, 1712, 1713, 1714, 1715, 1716, 1717, 1718
};

static const char _lexer_trans_keys[] = {
	-48, -17, 10, 32, 34, 35, 37, 42, 
	64, 124, 9, 13, -112, -105, -104, -102, 
	-100, -98, -97, -95, -92, -48, -69, -48, 
	-72, 32, 10, 10, 13, -48, 10, 32, 
	34, 35, 37, 42, 64, 124, 9, 13, 
	34, 34, 10, 13, 10, 13, 10, 32, 
	34, 9, 13, 10, 32, 34, 9, 13, 
	10, 32, 34, 9, 13, 10, 32, 34, 
	9, 13, 10, 32, 9, 13, 10, 32, 
	9, 13, 10, 13, 10, 95, 70, 69, 
	65, 84, 85, 82, 69, 95, 69, 78, 
	68, 95, 37, 13, 32, 64, 9, 10, 
	9, 10, 13, 32, 64, 11, 12, 10, 
	32, 64, 9, 13, 32, 124, 9, 13, 
	10, 32, 92, 124, 9, 13, 10, 92, 
	124, 10, 92, 10, 32, 92, 124, 9, 
	13, -48, 10, 32, 34, 35, 37, 42, 
	64, 124, 9, 13, -48, -80, -48, -76, 
	-48, -80, -47, -126, -48, -75, -72, -66, 
	-48, -80, -66, -48, -76, -48, 32, -80, 
	-48, -67, -47, -126, -122, -48, -75, -48, 
	-70, -47, -127, -47, -126, 58, 10, 10, 
	-48, 10, 32, 35, 37, 42, 64, 9, 
	13, -112, -105, -104, -102, -100, -98, -97, 
	-95, -92, 10, -48, 10, -69, 10, -48, 
	10, -72, 10, 10, 32, -48, 10, 32, 
	34, 35, 37, 42, 64, 124, 9, 13, 
	-48, 10, -80, 10, -48, 10, -76, 10, 
	-48, 10, -80, 10, -47, 10, -126, 10, 
	-48, 10, -75, -72, -66, 10, -48, 10, 
	-80, -66, 10, -48, 10, -76, 10, -48, 
	10, 32, -80, 10, -48, 10, -67, 10, 
	-47, 10, -122, 10, -48, 10, -75, 10, 
	-48, 10, -65, 10, -47, 10, -126, 10, 
	10, 58, -48, 10, -66, 10, -48, 10, 
	-77, 10, -47, 10, -125, 10, -47, 10, 
	-101, 10, -48, 10, -67, 10, -48, 10, 
	-66, 10, -47, 10, -127, 10, -48, -47, 
	10, -67, 10, -48, 10, -76, 10, -48, 
	10, -127, 10, -48, 10, -66, 10, -48, 
	10, -79, 10, -48, 10, -72, 10, -48, 
	10, -67, 10, -48, 10, -80, 10, -47, 
	10, -128, 10, -48, 10, -72, 10, -48, 
	10, -68, 10, -48, 10, -75, 10, -47, 
	10, -128, 10, -48, -47, 10, -70, 10, 
	-48, 10, -72, 10, -47, 10, -122, 10, 
	-126, -122, 10, -47, 10, -128, 10, -47, 
	10, -125, 10, -48, 10, -70, 10, -47, 
	10, -126, 10, -47, 10, -125, 10, -47, 
	10, -128, 10, -48, 10, -80, 10, 10, 
	32, -47, 10, -127, 10, -47, 10, -122, 
	10, -48, 10, -75, 10, -48, 10, -67, 
	10, -48, 10, -80, 10, -47, 10, -128, 
	10, -48, 10, -72, 10, -47, 10, -104, 
	10, -48, 10, -75, 10, -48, 10, -67, 
	10, -48, 10, -80, 10, -47, 10, -128, 
	10, -48, 10, -72, 10, -48, 10, -66, 
	10, -47, 10, -125, 10, -48, 10, -67, 
	10, -48, 10, -70, 10, -47, 10, -122, 
	10, -48, 10, -72, 10, -48, 10, -66, 
	10, -48, 10, -67, 10, -48, 10, -80, 
	10, -48, 10, -69, 10, 10, 95, 10, 
	70, 10, 69, 10, 65, 10, 84, 10, 
	85, 10, 82, 10, 69, 10, 95, 10, 
	69, 10, 78, 10, 68, 10, 95, 10, 
	37, -48, -75, -48, -65, -47, -126, 58, 
	10, 10, -48, 10, 32, 35, 37, 42, 
	64, 9, 13, -112, -105, -104, -102, -100, 
	-98, -97, -95, -92, 10, -48, 10, -69, 
	10, -48, 10, -72, 10, 10, 32, -48, 
	10, -80, 10, -48, 10, -76, 10, -48, 
	10, -80, 10, -47, 10, -126, 10, -48, 
	10, -75, -72, -66, 10, -48, 10, -80, 
	10, -48, 10, -76, 10, -48, 10, 32, 
	-80, 10, -48, 10, -66, 10, -48, 10, 
	-77, 10, -47, 10, -125, 10, -47, 10, 
	-101, 10, -48, 10, -67, 10, -48, 10, 
	-66, 10, -47, 10, -127, 10, -47, 10, 
	-126, 10, 10, 58, -48, -47, 10, -67, 
	10, -48, 10, -76, 10, -48, 10, -127, 
	10, -48, 10, -66, 10, -48, 10, -79, 
	10, -48, 10, -72, 10, -48, 10, -67, 
	10, -48, 10, -80, 10, -47, 10, -128, 
	10, -48, 10, -72, 10, -48, 10, -68, 
	10, -48, 10, -75, 10, -47, 10, -128, 
	10, -47, 10, -122, 10, -48, 10, -75, 
	10, -48, 10, -67, 10, -48, 10, -80, 
	10, -47, 10, -128, 10, -48, 10, -72, 
	10, -48, 10, -66, 10, -47, 10, -125, 
	10, -48, 10, -67, 10, -48, 10, -70, 
	10, -47, 10, -122, 10, -48, 10, -72, 
	10, -48, 10, -66, 10, -48, 10, -67, 
	10, -48, 10, -80, 10, -48, 10, -69, 
	10, 10, 95, 10, 70, 10, 69, 10, 
	65, 10, 84, 10, 85, 10, 82, 10, 
	69, 10, 95, 10, 69, 10, 78, 10, 
	68, 10, 95, 10, 37, -48, -66, -48, 
	-77, -47, -125, -47, -101, -48, -67, -48, 
	-66, -47, -127, -47, -126, 58, 10, 10, 
	-48, 10, 32, 35, 37, 64, 9, 13, 
	-102, -100, -98, -97, -95, -92, 10, -48, 
	10, -66, 10, -48, 10, -67, 10, -47, 
	10, -126, -122, 10, -48, 10, -75, 10, 
	-48, 10, -70, 10, -47, 10, -127, 10, 
	-47, 10, -126, 10, 10, 58, -48, 10, 
	-75, 10, -48, 10, -65, 10, -48, 10, 
	-66, 10, -48, 10, -77, 10, -47, 10, 
	-125, 10, -47, 10, -101, 10, -48, 10, 
	-67, 10, -48, 10, -66, 10, -47, 10, 
	-127, 10, -48, 10, -67, -66, 10, -48, 
	10, -66, 10, -48, 10, -78, 10, -48, 
	10, -80, 10, -48, 10, -79, 10, -48, 
	10, -72, 10, -48, 10, -67, 10, -48, 
	-47, 10, -66, 10, -48, 10, -73, 10, 
	-48, 10, -80, 10, -48, 10, -76, 10, 
	-128, 10, -48, 10, -72, 10, -48, 10, 
	-68, 10, -48, 10, -75, 10, -47, 10, 
	-128, 10, -48, 10, 58, -72, 10, -48, 
	-47, 10, -70, 10, -48, 10, -72, 10, 
	-47, 10, -122, 10, -126, -122, 10, -47, 
	10, -128, 10, -47, 10, -125, 10, -48, 
	10, -70, 10, -47, 10, -126, 10, -47, 
	10, -125, 10, -47, 10, -128, 10, -48, 
	10, -80, 10, 10, 32, -47, 10, -127, 
	10, -47, 10, -122, 10, -48, 10, -75, 
	10, -48, 10, -67, 10, -48, 10, -80, 
	10, -47, 10, -128, 10, -48, 10, -72, 
	10, -47, 10, -104, 10, -48, 10, -75, 
	10, -48, 10, -67, 10, -48, 10, -80, 
	10, -47, 10, -128, 10, -48, 10, -72, 
	10, -48, -47, 10, -66, 10, -104, 10, 
	-48, 10, -47, 10, -125, 10, -48, 10, 
	-67, 10, -48, 10, -70, 10, -47, 10, 
	-122, 10, -48, 10, -72, 10, -48, 10, 
	-66, 10, -48, 10, -67, 10, -48, 10, 
	-80, 10, -48, 10, -69, 10, 10, 95, 
	10, 70, 10, 69, 10, 65, 10, 84, 
	10, 85, 10, 82, 10, 69, 10, 95, 
	10, 69, 10, 78, 10, 68, 10, 95, 
	10, 37, -48, -47, -67, -48, -76, -48, 
	-127, -48, -67, -66, -48, -66, -48, -78, 
	-48, -80, -48, -79, -48, -72, -48, -67, 
	-48, -80, -48, -47, -66, -48, -73, -48, 
	-80, -48, -76, -48, -72, -48, -67, -128, 
	-48, -72, -48, -68, -48, -75, -47, -128, 
	-48, 58, -72, 58, 10, 10, -48, 10, 
	32, 35, 124, 9, 13, -100, -98, -92, 
	10, -48, 10, -66, 10, -48, 10, -77, 
	10, -47, 10, -125, 10, -47, 10, -101, 
	10, -48, 10, -67, 10, -48, 10, -66, 
	10, -47, 10, -127, 10, -47, 10, -126, 
	10, 10, 58, -47, 10, -127, 10, -48, 
	10, -66, 10, -48, 10, -79, 10, -48, 
	10, -72, 10, -48, 10, -67, 10, -48, 
	10, -80, 10, -47, 10, -125, 10, -48, 
	10, -67, 10, -48, 10, -70, 10, -47, 
	10, -122, 10, -48, 10, -72, 10, -48, 
	10, -66, 10, -48, 10, -67, 10, -48, 
	10, -80, 10, -48, 10, -69, 10, 10, 
	10, -48, 10, 32, 35, 37, 42, 64, 
	9, 13, -112, -105, -104, -102, -100, -98, 
	-97, -95, -92, 10, -48, 10, -69, 10, 
	-48, 10, -72, 10, 10, 32, -48, 10, 
	-80, 10, -48, 10, -76, 10, -48, 10, 
	-80, 10, -47, 10, -126, 10, -48, 10, 
	-75, -72, -66, 10, -48, 10, -80, -66, 
	10, -48, 10, -76, 10, -48, 10, 32, 
	-80, 10, -48, 10, -67, 10, -47, 10, 
	-126, -122, 10, -48, 10, -75, 10, -48, 
	10, -70, 10, -47, 10, -127, 10, -47, 
	10, -126, 10, 10, 58, -48, 10, -75, 
	10, -48, 10, -65, 10, -48, 10, -66, 
	10, -48, 10, -77, 10, -47, 10, -125, 
	10, -47, 10, -101, 10, -48, 10, -67, 
	10, -48, 10, -66, 10, -48, -47, 10, 
	-67, 10, -48, 10, -76, 10, -48, 10, 
	-127, 10, -48, 10, -67, -66, 10, -48, 
	10, -66, 10, -48, 10, -78, 10, -48, 
	10, -80, 10, -48, 10, -79, 10, -48, 
	10, -72, 10, -48, 10, -67, 10, -48, 
	-47, 10, -66, 10, -48, 10, -73, 10, 
	-48, 10, -80, 10, -48, 10, -76, 10, 
	-128, 10, -48, 10, -72, 10, -48, 10, 
	-68, 10, -48, 10, -75, 10, -47, 10, 
	-128, 10, -48, -47, 10, -70, 10, -48, 
	10, -72, 10, -47, 10, -122, 10, -126, 
	-122, 10, -47, 10, -128, 10, -47, 10, 
	-125, 10, -48, 10, -70, 10, -47, 10, 
	-126, 10, -47, 10, -125, 10, -47, 10, 
	-128, 10, -48, 10, -80, 10, 10, 32, 
	-47, 10, -127, 10, -47, 10, -122, 10, 
	-48, 10, -75, 10, -48, 10, -67, 10, 
	-48, 10, -80, 10, -47, 10, -128, 10, 
	-48, 10, -72, 10, -47, 10, -104, 10, 
	-48, 10, -75, 10, -48, 10, -67, 10, 
	-48, 10, -80, 10, -47, 10, -128, 10, 
	-48, 10, -72, 10, -48, 10, -66, 10, 
	-47, 10, -125, 10, -48, 10, -67, 10, 
	-48, 10, -70, 10, -47, 10, -122, 10, 
	-48, 10, -72, 10, -48, 10, -66, 10, 
	-48, 10, -67, 10, -48, 10, -80, 10, 
	-48, 10, -69, 10, 10, 95, 10, 70, 
	10, 69, 10, 65, 10, 84, 10, 85, 
	10, 82, 10, 69, 10, 95, 10, 69, 
	10, 78, 10, 68, 10, 95, 10, 37, 
	-48, -47, -70, -48, -72, -47, -122, -48, 
	-80, -126, -122, -47, -128, -47, -125, -48, 
	-70, -47, -126, -47, -125, -47, -128, -48, 
	-80, 32, -47, -127, -47, -122, -48, -75, 
	-48, -67, -48, -80, -47, -128, -48, -72, 
	-47, -104, -48, -75, -48, -67, -48, -80, 
	-47, -128, -48, -72, -48, -47, -66, 58, 
	-104, -48, -47, -125, -48, -67, -48, -70, 
	-47, -122, -48, -72, -48, -66, -48, -67, 
	-48, -80, -48, -69, -69, -65, 0
};

static const char _lexer_single_lengths[] = {
	0, 10, 9, 1, 1, 1, 1, 1, 
	1, 2, 9, 1, 1, 2, 2, 3, 
	3, 3, 3, 2, 2, 2, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 3, 5, 3, 
	2, 4, 3, 2, 4, 9, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 3, 
	1, 2, 1, 1, 2, 1, 1, 1, 
	1, 2, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 7, 10, 2, 
	2, 2, 2, 2, 9, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 4, 2, 
	3, 2, 2, 3, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 3, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	3, 2, 2, 2, 2, 2, 3, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 7, 10, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 4, 2, 2, 2, 2, 
	3, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 3, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 6, 7, 
	2, 2, 2, 2, 2, 3, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 3, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 3, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	3, 2, 3, 2, 2, 2, 2, 2, 
	3, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 3, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 1, 
	1, 1, 1, 1, 1, 2, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 2, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 2, 1, 1, 1, 1, 5, 4, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 1, 
	1, 7, 10, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 4, 2, 3, 2, 2, 3, 2, 
	2, 2, 2, 3, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 3, 2, 2, 
	2, 2, 2, 2, 3, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 3, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 3, 2, 2, 2, 2, 2, 
	3, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 1, 1, 1, 
	1, 1, 1, 1, 2, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 2, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 0
};

static const char _lexer_range_lengths[] = {
	0, 1, 0, 0, 0, 0, 0, 0, 
	0, 0, 1, 0, 0, 0, 0, 1, 
	1, 1, 1, 1, 1, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 1, 1, 1, 
	1, 1, 0, 0, 1, 1, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 1, 0, 0, 
	0, 0, 0, 0, 1, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 1, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 1, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 1, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 1, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0
};

static const short _lexer_index_offsets[] = {
	0, 0, 12, 22, 24, 26, 28, 30, 
	32, 34, 37, 48, 50, 52, 55, 58, 
	63, 68, 73, 78, 82, 86, 89, 91, 
	93, 95, 97, 99, 101, 103, 105, 107, 
	109, 111, 113, 115, 117, 119, 124, 131, 
	136, 140, 146, 150, 153, 159, 170, 172, 
	174, 176, 178, 180, 182, 184, 186, 188, 
	192, 194, 197, 199, 201, 204, 206, 208, 
	210, 212, 215, 217, 219, 221, 223, 225, 
	227, 229, 231, 233, 235, 237, 246, 257, 
	260, 263, 266, 269, 272, 283, 286, 289, 
	292, 295, 298, 301, 304, 307, 310, 315, 
	318, 322, 325, 328, 332, 335, 338, 341, 
	344, 347, 350, 353, 356, 359, 362, 365, 
	368, 371, 374, 377, 380, 383, 386, 389, 
	392, 395, 398, 401, 404, 407, 410, 414, 
	417, 420, 423, 426, 429, 432, 435, 438, 
	441, 444, 447, 450, 453, 456, 459, 462, 
	465, 468, 471, 474, 477, 480, 483, 486, 
	489, 493, 496, 499, 502, 505, 508, 512, 
	515, 518, 521, 524, 527, 530, 533, 536, 
	539, 542, 545, 548, 551, 554, 557, 560, 
	563, 566, 569, 572, 575, 578, 581, 584, 
	587, 590, 593, 596, 599, 602, 605, 608, 
	611, 614, 617, 620, 623, 626, 629, 632, 
	635, 638, 641, 644, 647, 650, 653, 656, 
	659, 662, 665, 668, 671, 674, 677, 680, 
	683, 686, 689, 692, 695, 698, 701, 704, 
	707, 710, 713, 716, 719, 722, 725, 728, 
	731, 734, 737, 739, 741, 743, 745, 747, 
	749, 751, 753, 755, 764, 775, 778, 781, 
	784, 787, 790, 793, 796, 799, 802, 805, 
	808, 811, 814, 817, 822, 825, 828, 831, 
	834, 838, 841, 844, 847, 850, 853, 856, 
	859, 862, 865, 868, 871, 874, 877, 880, 
	883, 886, 889, 892, 896, 899, 902, 905, 
	908, 911, 914, 917, 920, 923, 926, 929, 
	932, 935, 938, 941, 944, 947, 950, 953, 
	956, 959, 962, 965, 968, 971, 974, 977, 
	980, 983, 986, 989, 992, 995, 998, 1001, 
	1004, 1007, 1010, 1013, 1016, 1019, 1022, 1025, 
	1028, 1031, 1034, 1037, 1040, 1043, 1046, 1049, 
	1052, 1055, 1058, 1061, 1064, 1067, 1070, 1073, 
	1076, 1079, 1082, 1085, 1088, 1091, 1094, 1097, 
	1100, 1103, 1106, 1109, 1111, 1113, 1115, 1117, 
	1119, 1121, 1123, 1125, 1127, 1129, 1131, 1133, 
	1135, 1137, 1139, 1141, 1143, 1145, 1147, 1155, 
	1163, 1166, 1169, 1172, 1175, 1178, 1182, 1185, 
	1188, 1191, 1194, 1197, 1200, 1203, 1206, 1209, 
	1212, 1215, 1218, 1221, 1224, 1227, 1230, 1233, 
	1236, 1239, 1242, 1245, 1248, 1251, 1254, 1257, 
	1260, 1263, 1266, 1270, 1273, 1276, 1279, 1282, 
	1285, 1288, 1291, 1294, 1297, 1300, 1303, 1306, 
	1310, 1313, 1316, 1319, 1322, 1325, 1328, 1331, 
	1334, 1337, 1340, 1343, 1346, 1349, 1352, 1355, 
	1358, 1362, 1365, 1369, 1372, 1375, 1378, 1381, 
	1384, 1388, 1391, 1394, 1397, 1400, 1403, 1406, 
	1409, 1412, 1415, 1418, 1421, 1424, 1427, 1430, 
	1433, 1436, 1439, 1442, 1445, 1448, 1451, 1454, 
	1457, 1460, 1463, 1466, 1469, 1472, 1475, 1478, 
	1481, 1484, 1487, 1490, 1493, 1496, 1499, 1502, 
	1505, 1508, 1511, 1515, 1518, 1521, 1524, 1527, 
	1530, 1533, 1536, 1539, 1542, 1545, 1548, 1551, 
	1554, 1557, 1560, 1563, 1566, 1569, 1572, 1575, 
	1578, 1581, 1584, 1587, 1590, 1593, 1596, 1599, 
	1602, 1605, 1608, 1611, 1614, 1617, 1620, 1623, 
	1625, 1627, 1629, 1631, 1633, 1635, 1638, 1640, 
	1642, 1644, 1646, 1648, 1650, 1652, 1654, 1656, 
	1658, 1660, 1662, 1664, 1666, 1669, 1671, 1673, 
	1675, 1677, 1679, 1681, 1683, 1685, 1687, 1689, 
	1691, 1693, 1695, 1697, 1699, 1701, 1703, 1705, 
	1707, 1709, 1712, 1714, 1716, 1718, 1720, 1727, 
	1732, 1735, 1738, 1741, 1744, 1747, 1750, 1753, 
	1756, 1759, 1762, 1765, 1768, 1771, 1774, 1777, 
	1780, 1783, 1786, 1789, 1792, 1795, 1798, 1801, 
	1804, 1807, 1810, 1813, 1816, 1819, 1822, 1825, 
	1828, 1831, 1834, 1837, 1840, 1843, 1846, 1849, 
	1852, 1855, 1858, 1861, 1864, 1867, 1870, 1873, 
	1875, 1877, 1886, 1897, 1900, 1903, 1906, 1909, 
	1912, 1915, 1918, 1921, 1924, 1927, 1930, 1933, 
	1936, 1939, 1944, 1947, 1951, 1954, 1957, 1961, 
	1964, 1967, 1970, 1973, 1977, 1980, 1983, 1986, 
	1989, 1992, 1995, 1998, 2001, 2004, 2007, 2010, 
	2013, 2016, 2019, 2022, 2025, 2028, 2031, 2034, 
	2037, 2040, 2043, 2046, 2049, 2052, 2056, 2059, 
	2062, 2065, 2068, 2071, 2074, 2078, 2081, 2084, 
	2087, 2090, 2093, 2096, 2099, 2102, 2105, 2108, 
	2111, 2114, 2118, 2121, 2124, 2127, 2130, 2133, 
	2136, 2139, 2142, 2145, 2148, 2151, 2154, 2157, 
	2160, 2163, 2166, 2170, 2173, 2176, 2179, 2182, 
	2185, 2189, 2192, 2195, 2198, 2201, 2204, 2207, 
	2210, 2213, 2216, 2219, 2222, 2225, 2228, 2231, 
	2234, 2237, 2240, 2243, 2246, 2249, 2252, 2255, 
	2258, 2261, 2264, 2267, 2270, 2273, 2276, 2279, 
	2282, 2285, 2288, 2291, 2294, 2297, 2300, 2303, 
	2306, 2309, 2312, 2315, 2318, 2321, 2324, 2327, 
	2330, 2333, 2336, 2339, 2342, 2345, 2348, 2351, 
	2354, 2357, 2360, 2363, 2366, 2369, 2372, 2375, 
	2378, 2381, 2384, 2387, 2390, 2393, 2396, 2399, 
	2402, 2405, 2408, 2411, 2414, 2417, 2419, 2421, 
	2423, 2425, 2427, 2429, 2431, 2434, 2436, 2438, 
	2440, 2442, 2444, 2446, 2448, 2450, 2452, 2454, 
	2456, 2458, 2460, 2462, 2464, 2466, 2468, 2470, 
	2472, 2474, 2476, 2478, 2480, 2482, 2484, 2486, 
	2488, 2490, 2492, 2494, 2496, 2498, 2500, 2502, 
	2504, 2506, 2508, 2510, 2512, 2514, 2516, 2519, 
	2521, 2523, 2525, 2527, 2529, 2531, 2533, 2535, 
	2537, 2539, 2541, 2543, 2545, 2547, 2549, 2551, 
	2553, 2555, 2557, 2559, 2561, 2563, 2565, 2567
};

static const short _lexer_trans_targs[] = {
	2, 869, 10, 10, 11, 21, 23, 7, 
	37, 40, 10, 0, 3, 46, 7, 56, 
	355, 526, 548, 796, 851, 0, 4, 0, 
	5, 0, 6, 0, 7, 0, 8, 0, 
	0, 9, 10, 22, 9, 2, 10, 10, 
	11, 21, 23, 7, 37, 40, 10, 0, 
	12, 0, 13, 0, 15, 14, 14, 15, 
	14, 14, 16, 16, 17, 16, 16, 16, 
	16, 17, 16, 16, 16, 16, 18, 16, 
	16, 16, 16, 19, 16, 16, 10, 20, 
	20, 0, 10, 20, 20, 0, 10, 22, 
	21, 10, 0, 24, 0, 25, 0, 26, 
	0, 27, 0, 28, 0, 29, 0, 30, 
	0, 31, 0, 32, 0, 33, 0, 34, 
	0, 35, 0, 36, 0, 871, 0, 0, 
	0, 0, 0, 38, 39, 10, 39, 39, 
	37, 38, 38, 10, 39, 37, 39, 0, 
	40, 41, 40, 0, 45, 44, 43, 41, 
	44, 42, 0, 43, 41, 42, 0, 43, 
	42, 45, 44, 43, 41, 44, 42, 2, 
	45, 45, 11, 21, 23, 7, 37, 40, 
	45, 0, 47, 0, 48, 0, 49, 0, 
	50, 0, 51, 0, 52, 0, 53, 0, 
	54, 0, 55, 0, 7, 7, 7, 0, 
	57, 0, 58, 62, 0, 59, 0, 60, 
	0, 61, 8, 0, 7, 0, 63, 0, 
	64, 0, 65, 0, 66, 234, 0, 67, 
	0, 68, 0, 69, 0, 70, 0, 71, 
	0, 72, 0, 73, 0, 74, 0, 75, 
	0, 77, 76, 77, 76, 78, 77, 77, 
	10, 220, 83, 10, 77, 76, 79, 85, 
	83, 95, 112, 126, 142, 152, 202, 77, 
	76, 80, 77, 76, 81, 77, 76, 82, 
	77, 76, 83, 77, 76, 77, 84, 76, 
	2, 10, 10, 11, 21, 23, 7, 37, 
	40, 10, 0, 86, 77, 76, 87, 77, 
	76, 88, 77, 76, 89, 77, 76, 90, 
	77, 76, 91, 77, 76, 92, 77, 76, 
	93, 77, 76, 94, 77, 76, 83, 83, 
	83, 77, 76, 96, 77, 76, 97, 101, 
	77, 76, 98, 77, 76, 99, 77, 76, 
	100, 77, 84, 76, 83, 77, 76, 102, 
	77, 76, 103, 77, 76, 104, 77, 76, 
	105, 77, 76, 106, 77, 76, 107, 77, 
	76, 108, 77, 76, 109, 77, 76, 110, 
	77, 76, 111, 77, 76, 77, 84, 76, 
	113, 77, 76, 114, 77, 76, 115, 77, 
	76, 116, 77, 76, 117, 77, 76, 118, 
	77, 76, 119, 77, 76, 120, 77, 76, 
	121, 77, 76, 122, 77, 76, 123, 77, 
	76, 124, 77, 76, 125, 77, 76, 109, 
	77, 76, 127, 131, 77, 76, 128, 77, 
	76, 129, 77, 76, 130, 77, 76, 100, 
	77, 76, 132, 77, 76, 133, 77, 76, 
	134, 77, 76, 135, 77, 76, 136, 77, 
	76, 137, 77, 76, 138, 77, 76, 139, 
	77, 76, 140, 77, 76, 141, 77, 76, 
	111, 77, 76, 143, 77, 76, 144, 77, 
	76, 145, 77, 76, 146, 77, 76, 147, 
	77, 76, 148, 77, 76, 149, 77, 76, 
	150, 77, 76, 151, 77, 76, 111, 77, 
	76, 153, 158, 77, 76, 154, 77, 76, 
	155, 77, 76, 156, 77, 76, 157, 77, 
	76, 140, 77, 76, 159, 190, 77, 76, 
	160, 77, 76, 161, 77, 76, 162, 77, 
	76, 163, 77, 76, 164, 77, 76, 165, 
	77, 76, 166, 77, 76, 167, 77, 76, 
	168, 77, 76, 169, 77, 76, 170, 77, 
	76, 171, 77, 76, 172, 77, 76, 173, 
	77, 76, 77, 174, 76, 175, 77, 76, 
	176, 77, 76, 177, 77, 76, 178, 77, 
	76, 179, 77, 76, 180, 77, 76, 181, 
	77, 76, 182, 77, 76, 183, 77, 76, 
	184, 77, 76, 185, 77, 76, 186, 77, 
	76, 187, 77, 76, 188, 77, 76, 189, 
	77, 76, 140, 77, 76, 191, 77, 76, 
	192, 77, 76, 193, 77, 76, 194, 77, 
	76, 195, 77, 76, 196, 77, 76, 197, 
	77, 76, 198, 77, 76, 199, 77, 76, 
	200, 77, 76, 201, 77, 76, 111, 77, 
	76, 203, 77, 76, 204, 77, 76, 205, 
	77, 76, 206, 77, 76, 207, 77, 76, 
	208, 77, 76, 209, 77, 76, 210, 77, 
	76, 211, 77, 76, 212, 77, 76, 213, 
	77, 76, 214, 77, 76, 215, 77, 76, 
	216, 77, 76, 217, 77, 76, 218, 77, 
	76, 219, 77, 76, 120, 77, 76, 77, 
	221, 76, 77, 222, 76, 77, 223, 76, 
	77, 224, 76, 77, 225, 76, 77, 226, 
	76, 77, 227, 76, 77, 228, 76, 77, 
	229, 76, 77, 230, 76, 77, 231, 76, 
	77, 232, 76, 77, 233, 76, 77, 10, 
	76, 235, 0, 236, 0, 237, 0, 238, 
	0, 239, 0, 240, 0, 241, 0, 243, 
	242, 243, 242, 244, 243, 243, 10, 341, 
	249, 10, 243, 242, 245, 250, 249, 260, 
	266, 283, 299, 309, 323, 243, 242, 246, 
	243, 242, 247, 243, 242, 248, 243, 242, 
	249, 243, 242, 243, 84, 242, 251, 243, 
	242, 252, 243, 242, 253, 243, 242, 254, 
	243, 242, 255, 243, 242, 256, 243, 242, 
	257, 243, 242, 258, 243, 242, 259, 243, 
	242, 249, 249, 249, 243, 242, 261, 243, 
	242, 262, 243, 242, 263, 243, 242, 264, 
	243, 242, 265, 243, 84, 242, 249, 243, 
	242, 267, 243, 242, 268, 243, 242, 269, 
	243, 242, 270, 243, 242, 271, 243, 242, 
	272, 243, 242, 273, 243, 242, 274, 243, 
	242, 275, 243, 242, 276, 243, 242, 277, 
	243, 242, 278, 243, 242, 279, 243, 242, 
	280, 243, 242, 281, 243, 242, 282, 243, 
	242, 243, 84, 242, 284, 288, 243, 242, 
	285, 243, 242, 286, 243, 242, 287, 243, 
	242, 265, 243, 242, 289, 243, 242, 290, 
	243, 242, 291, 243, 242, 292, 243, 242, 
	293, 243, 242, 294, 243, 242, 295, 243, 
	242, 296, 243, 242, 297, 243, 242, 298, 
	243, 242, 282, 243, 242, 300, 243, 242, 
	301, 243, 242, 302, 243, 242, 303, 243, 
	242, 304, 243, 242, 305, 243, 242, 306, 
	243, 242, 307, 243, 242, 308, 243, 242, 
	282, 243, 242, 310, 243, 242, 311, 243, 
	242, 312, 243, 242, 313, 243, 242, 314, 
	243, 242, 315, 243, 242, 316, 243, 242, 
	317, 243, 242, 318, 243, 242, 319, 243, 
	242, 320, 243, 242, 321, 243, 242, 322, 
	243, 242, 282, 243, 242, 324, 243, 242, 
	325, 243, 242, 326, 243, 242, 327, 243, 
	242, 328, 243, 242, 329, 243, 242, 330, 
	243, 242, 331, 243, 242, 332, 243, 242, 
	333, 243, 242, 334, 243, 242, 335, 243, 
	242, 336, 243, 242, 337, 243, 242, 338, 
	243, 242, 339, 243, 242, 340, 243, 242, 
	274, 243, 242, 243, 342, 242, 243, 343, 
	242, 243, 344, 242, 243, 345, 242, 243, 
	346, 242, 243, 347, 242, 243, 348, 242, 
	243, 349, 242, 243, 350, 242, 243, 351, 
	242, 243, 352, 242, 243, 353, 242, 243, 
	354, 242, 243, 10, 242, 356, 0, 357, 
	0, 358, 0, 359, 0, 360, 0, 361, 
	0, 362, 0, 363, 0, 364, 0, 365, 
	0, 366, 0, 367, 0, 368, 0, 369, 
	0, 370, 0, 371, 0, 372, 0, 374, 
	373, 374, 373, 375, 374, 374, 10, 512, 
	10, 374, 373, 376, 395, 407, 423, 442, 
	494, 374, 373, 377, 374, 373, 378, 374, 
	373, 379, 374, 373, 380, 374, 373, 381, 
	374, 373, 382, 391, 374, 373, 383, 374, 
	373, 384, 374, 373, 385, 374, 373, 386, 
	374, 373, 387, 374, 373, 388, 374, 373, 
	389, 374, 373, 390, 374, 373, 374, 84, 
	373, 392, 374, 373, 393, 374, 373, 394, 
	374, 373, 388, 374, 373, 396, 374, 373, 
	397, 374, 373, 398, 374, 373, 399, 374, 
	373, 400, 374, 373, 401, 374, 373, 402, 
	374, 373, 403, 374, 373, 404, 374, 373, 
	405, 374, 373, 406, 374, 373, 386, 374, 
	373, 408, 374, 373, 409, 374, 373, 410, 
	374, 373, 411, 417, 374, 373, 412, 374, 
	373, 413, 374, 373, 414, 374, 373, 415, 
	374, 373, 416, 374, 373, 390, 374, 373, 
	418, 374, 373, 419, 374, 373, 420, 374, 
	373, 421, 374, 373, 422, 374, 373, 415, 
	374, 373, 424, 431, 374, 373, 425, 374, 
	373, 426, 374, 373, 427, 374, 373, 428, 
	374, 373, 429, 374, 373, 430, 374, 373, 
	419, 374, 373, 432, 374, 373, 433, 374, 
	373, 434, 374, 373, 435, 374, 373, 436, 
	374, 373, 437, 374, 373, 438, 374, 373, 
	439, 374, 373, 440, 374, 373, 441, 374, 
	84, 373, 390, 374, 373, 443, 448, 374, 
	373, 444, 374, 373, 445, 374, 373, 446, 
	374, 373, 447, 374, 373, 415, 374, 373, 
	449, 480, 374, 373, 450, 374, 373, 451, 
	374, 373, 452, 374, 373, 453, 374, 373, 
	454, 374, 373, 455, 374, 373, 456, 374, 
	373, 457, 374, 373, 458, 374, 373, 459, 
	374, 373, 460, 374, 373, 461, 374, 373, 
	462, 374, 373, 463, 374, 373, 374, 464, 
	373, 465, 374, 373, 466, 374, 373, 467, 
	374, 373, 468, 374, 373, 469, 374, 373, 
	470, 374, 373, 471, 374, 373, 472, 374, 
	373, 473, 374, 373, 474, 374, 373, 475, 
	374, 373, 476, 374, 373, 477, 374, 373, 
	478, 374, 373, 479, 374, 373, 415, 374, 
	373, 481, 374, 373, 482, 374, 373, 483, 
	374, 373, 484, 374, 373, 485, 374, 373, 
	486, 374, 373, 487, 374, 373, 488, 374, 
	373, 489, 374, 373, 490, 374, 373, 491, 
	492, 374, 373, 390, 374, 373, 493, 374, 
	373, 441, 374, 373, 495, 374, 373, 496, 
	374, 373, 497, 374, 373, 498, 374, 373, 
	499, 374, 373, 500, 374, 373, 501, 374, 
	373, 502, 374, 373, 503, 374, 373, 504, 
	374, 373, 505, 374, 373, 506, 374, 373, 
	507, 374, 373, 508, 374, 373, 509, 374, 
	373, 510, 374, 373, 511, 374, 373, 403, 
	374, 373, 374, 513, 373, 374, 514, 373, 
	374, 515, 373, 374, 516, 373, 374, 517, 
	373, 374, 518, 373, 374, 519, 373, 374, 
	520, 373, 374, 521, 373, 374, 522, 373, 
	374, 523, 373, 374, 524, 373, 374, 525, 
	373, 374, 10, 373, 527, 531, 0, 528, 
	0, 529, 0, 530, 0, 61, 0, 532, 
	0, 533, 0, 534, 540, 0, 535, 0, 
	536, 0, 537, 0, 538, 0, 539, 0, 
	74, 0, 541, 0, 542, 0, 543, 0, 
	544, 0, 545, 0, 546, 0, 547, 0, 
	371, 0, 549, 560, 0, 550, 0, 551, 
	0, 552, 0, 553, 0, 554, 0, 555, 
	0, 556, 0, 557, 0, 558, 0, 559, 
	0, 538, 0, 561, 0, 562, 0, 563, 
	0, 564, 0, 565, 0, 566, 0, 567, 
	0, 568, 0, 569, 0, 570, 623, 0, 
	571, 0, 572, 0, 574, 573, 574, 573, 
	575, 574, 574, 10, 10, 574, 573, 576, 
	593, 605, 574, 573, 577, 574, 573, 578, 
	574, 573, 579, 574, 573, 580, 574, 573, 
	581, 574, 573, 582, 574, 573, 583, 574, 
	573, 584, 574, 573, 585, 574, 573, 586, 
	574, 573, 587, 574, 573, 588, 574, 573, 
	589, 574, 573, 590, 574, 573, 591, 574, 
	573, 592, 574, 573, 574, 84, 573, 594, 
	574, 573, 595, 574, 573, 596, 574, 573, 
	597, 574, 573, 598, 574, 573, 599, 574, 
	573, 600, 574, 573, 601, 574, 573, 602, 
	574, 573, 603, 574, 573, 604, 574, 573, 
	592, 574, 573, 606, 574, 573, 607, 574, 
	573, 608, 574, 573, 609, 574, 573, 610, 
	574, 573, 611, 574, 573, 612, 574, 573, 
	613, 574, 573, 614, 574, 573, 615, 574, 
	573, 616, 574, 573, 617, 574, 573, 618, 
	574, 573, 619, 574, 573, 620, 574, 573, 
	621, 574, 573, 622, 574, 573, 584, 574, 
	573, 625, 624, 625, 624, 626, 625, 625, 
	10, 782, 631, 10, 625, 624, 627, 632, 
	631, 642, 665, 677, 697, 714, 764, 625, 
	624, 628, 625, 624, 629, 625, 624, 630, 
	625, 624, 631, 625, 624, 625, 84, 624, 
	633, 625, 624, 634, 625, 624, 635, 625, 
	624, 636, 625, 624, 637, 625, 624, 638, 
	625, 624, 639, 625, 624, 640, 625, 624, 
	641, 625, 624, 631, 631, 631, 625, 624, 
	643, 625, 624, 644, 648, 625, 624, 645, 
	625, 624, 646, 625, 624, 647, 625, 84, 
	624, 631, 625, 624, 649, 625, 624, 650, 
	625, 624, 651, 625, 624, 652, 661, 625, 
	624, 653, 625, 624, 654, 625, 624, 655, 
	625, 624, 656, 625, 624, 657, 625, 624, 
	658, 625, 624, 659, 625, 624, 660, 625, 
	624, 625, 84, 624, 662, 625, 624, 663, 
	625, 624, 664, 625, 624, 658, 625, 624, 
	666, 625, 624, 667, 625, 624, 668, 625, 
	624, 669, 625, 624, 670, 625, 624, 671, 
	625, 624, 672, 625, 624, 673, 625, 624, 
	674, 625, 624, 675, 625, 624, 676, 625, 
	624, 656, 625, 624, 678, 682, 625, 624, 
	679, 625, 624, 680, 625, 624, 681, 625, 
	624, 647, 625, 624, 683, 625, 624, 684, 
	625, 624, 685, 691, 625, 624, 686, 625, 
	624, 687, 625, 624, 688, 625, 624, 689, 
	625, 624, 690, 625, 624, 660, 625, 624, 
	692, 625, 624, 693, 625, 624, 694, 625, 
	624, 695, 625, 624, 696, 625, 624, 689, 
	625, 624, 698, 705, 625, 624, 699, 625, 
	624, 700, 625, 624, 701, 625, 624, 702, 
	625, 624, 703, 625, 624, 704, 625, 624, 
	693, 625, 624, 706, 625, 624, 707, 625, 
	624, 708, 625, 624, 709, 625, 624, 710, 
	625, 624, 711, 625, 624, 712, 625, 624, 
	713, 625, 624, 660, 625, 624, 715, 720, 
	625, 624, 716, 625, 624, 717, 625, 624, 
	718, 625, 624, 719, 625, 624, 689, 625, 
	624, 721, 752, 625, 624, 722, 625, 624, 
	723, 625, 624, 724, 625, 624, 725, 625, 
	624, 726, 625, 624, 727, 625, 624, 728, 
	625, 624, 729, 625, 624, 730, 625, 624, 
	731, 625, 624, 732, 625, 624, 733, 625, 
	624, 734, 625, 624, 735, 625, 624, 625, 
	736, 624, 737, 625, 624, 738, 625, 624, 
	739, 625, 624, 740, 625, 624, 741, 625, 
	624, 742, 625, 624, 743, 625, 624, 744, 
	625, 624, 745, 625, 624, 746, 625, 624, 
	747, 625, 624, 748, 625, 624, 749, 625, 
	624, 750, 625, 624, 751, 625, 624, 689, 
	625, 624, 753, 625, 624, 754, 625, 624, 
	755, 625, 624, 756, 625, 624, 757, 625, 
	624, 758, 625, 624, 759, 625, 624, 760, 
	625, 624, 761, 625, 624, 762, 625, 624, 
	763, 625, 624, 660, 625, 624, 765, 625, 
	624, 766, 625, 624, 767, 625, 624, 768, 
	625, 624, 769, 625, 624, 770, 625, 624, 
	771, 625, 624, 772, 625, 624, 773, 625, 
	624, 774, 625, 624, 775, 625, 624, 776, 
	625, 624, 777, 625, 624, 778, 625, 624, 
	779, 625, 624, 780, 625, 624, 781, 625, 
	624, 673, 625, 624, 625, 783, 624, 625, 
	784, 624, 625, 785, 624, 625, 786, 624, 
	625, 787, 624, 625, 788, 624, 625, 789, 
	624, 625, 790, 624, 625, 791, 624, 625, 
	792, 624, 625, 793, 624, 625, 794, 624, 
	625, 795, 624, 625, 10, 624, 797, 804, 
	0, 798, 0, 799, 0, 800, 0, 801, 
	0, 802, 0, 803, 0, 240, 0, 805, 
	836, 0, 806, 0, 807, 0, 808, 0, 
	809, 0, 810, 0, 811, 0, 812, 0, 
	813, 0, 814, 0, 815, 0, 816, 0, 
	817, 0, 818, 0, 819, 0, 820, 0, 
	821, 0, 822, 0, 823, 0, 824, 0, 
	825, 0, 826, 0, 827, 0, 828, 0, 
	829, 0, 830, 0, 831, 0, 832, 0, 
	833, 0, 834, 0, 835, 0, 802, 0, 
	837, 0, 838, 0, 839, 0, 840, 0, 
	841, 0, 842, 0, 843, 0, 844, 0, 
	845, 0, 846, 0, 847, 849, 0, 848, 
	0, 623, 0, 850, 0, 570, 0, 852, 
	0, 853, 0, 854, 0, 855, 0, 856, 
	0, 857, 0, 858, 0, 859, 0, 860, 
	0, 861, 0, 862, 0, 863, 0, 864, 
	0, 865, 0, 866, 0, 867, 0, 868, 
	0, 363, 0, 870, 0, 10, 0, 0, 
	0
};

static const unsigned char _lexer_trans_actions[] = {
	29, 0, 54, 0, 5, 1, 0, 29, 
	1, 35, 0, 43, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	43, 57, 110, 23, 0, 29, 54, 0, 
	5, 1, 0, 29, 1, 35, 0, 43, 
	0, 43, 0, 43, 135, 48, 9, 106, 
	11, 0, 130, 45, 45, 45, 3, 122, 
	33, 33, 33, 0, 122, 33, 33, 33, 
	0, 122, 33, 0, 33, 0, 102, 7, 
	7, 43, 54, 0, 0, 43, 114, 25, 
	0, 54, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 43, 
	43, 43, 43, 0, 27, 118, 27, 27, 
	51, 27, 0, 54, 0, 1, 0, 43, 
	0, 0, 0, 43, 54, 37, 37, 87, 
	37, 37, 43, 0, 39, 0, 43, 0, 
	0, 54, 0, 0, 39, 0, 0, 96, 
	54, 0, 93, 90, 41, 96, 90, 99, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 0, 0, 43, 
	0, 43, 0, 0, 43, 0, 43, 0, 
	43, 0, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 140, 57, 54, 0, 84, 54, 0, 
	72, 33, 84, 72, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 54, 15, 0, 
	63, 126, 31, 60, 57, 31, 63, 57, 
	66, 31, 43, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 0, 
	0, 54, 0, 0, 54, 0, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 15, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 54, 15, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 54, 0, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 15, 
	0, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 140, 
	57, 54, 0, 84, 54, 0, 78, 33, 
	84, 78, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 54, 19, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 19, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 54, 19, 0, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 19, 0, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 140, 
	57, 54, 0, 84, 54, 0, 69, 33, 
	69, 0, 0, 0, 0, 0, 0, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 54, 13, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	13, 0, 0, 54, 0, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 54, 0, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 13, 0, 0, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 0, 43, 
	0, 43, 0, 43, 140, 57, 54, 0, 
	84, 54, 0, 81, 81, 0, 0, 0, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 54, 21, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 140, 57, 54, 0, 84, 54, 0, 
	75, 33, 84, 75, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 54, 17, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 0, 0, 54, 0, 
	0, 54, 0, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 17, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 54, 17, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 54, 
	0, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 17, 0, 0, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	0
};

static const unsigned char _lexer_eof_actions[] = {
	0, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43
};

static const int lexer_start = 1;
static const int lexer_first_final = 871;
static const int lexer_error = 0;

static const int lexer_en_main = 1;


#line 258 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"

static VALUE 
unindent(VALUE con, int start_col)
{
  VALUE re;
  // Gherkin will crash gracefully if the string representation of start_col pushes the pattern past 32 characters
  char pat[32]; 
  snprintf(pat, 32, "^[\t ]{0,%d}", start_col); 
  re = rb_reg_regcomp(rb_str_new2(pat));
  rb_funcall(con, rb_intern("gsub!"), 2, re, rb_str_new2(""));

  return Qnil;

}

static void 
store_kw_con(VALUE listener, const char * event_name, 
             const char * keyword_at, size_t keyword_length, 
             const char * at,         size_t length, 
             int current_line)
{
  VALUE con = Qnil, kw = Qnil;
  kw = ENCODED_STR_NEW(keyword_at, keyword_length);
  con = ENCODED_STR_NEW(at, length);
  rb_funcall(con, rb_intern("strip!"), 0);
  rb_funcall(listener, rb_intern(event_name), 3, kw, con, INT2FIX(current_line)); 
}

static void
store_multiline_kw_con(VALUE listener, const char * event_name,
                      const char * keyword_at, size_t keyword_length,
                      const char * at,         size_t length,
                      int current_line, int start_col)
{
  VALUE split;
  VALUE con = Qnil, kw = Qnil, name = Qnil, desc = Qnil;

  kw = ENCODED_STR_NEW(keyword_at, keyword_length);
  con = ENCODED_STR_NEW(at, length);

  unindent(con, start_col);
  
  split = rb_str_split(con, "\n");

  name = rb_funcall(split, rb_intern("shift"), 0);
  desc = rb_ary_join(split, rb_str_new2( "\n" ));

  if( name == Qnil ) 
  {
    name = rb_str_new2("");
  }
  if( rb_funcall(desc, rb_intern("size"), 0) == 0) 
  {
    desc = rb_str_new2("");
  }
  rb_funcall(name, rb_intern("strip!"), 0);
  rb_funcall(desc, rb_intern("rstrip!"), 0);
  rb_funcall(listener, rb_intern(event_name), 4, kw, name, desc, INT2FIX(current_line)); 
}

static void 
store_attr(VALUE listener, const char * attr_type,
           const char * at, size_t length, 
           int line)
{
  VALUE val = ENCODED_STR_NEW(at, length);
  rb_funcall(listener, rb_intern(attr_type), 2, val, INT2FIX(line));
}
static void 
store_docstring_content(VALUE listener, 
          int start_col, 
          const char *type_at, size_t type_length,
          const char *at, size_t length, 
          int current_line)
{
  VALUE re2;
  VALUE unescape_escaped_quotes;
  VALUE con = ENCODED_STR_NEW(at, length);
  VALUE con_type = ENCODED_STR_NEW(type_at, type_length);

  unindent(con, start_col);

  re2 = rb_reg_regcomp(rb_str_new2("\r\\Z"));
  unescape_escaped_quotes = rb_reg_regcomp(rb_str_new2("\\\\\"\\\\\"\\\\\""));
  rb_funcall(con, rb_intern("sub!"), 2, re2, rb_str_new2(""));
  rb_funcall(con_type, rb_intern("strip!"), 0);
  rb_funcall(con, rb_intern("gsub!"), 2, unescape_escaped_quotes, rb_str_new2("\"\"\""));
  rb_funcall(listener, rb_intern("doc_string"), 3, con_type, con, INT2FIX(current_line));
}
static void 
raise_lexer_error(const char * at, int line)
{ 
  rb_raise(rb_eGherkinLexingError, "Lexing error on line %d: '%s'. See http://wiki.github.com/cucumber/gherkin/lexingerror for more information.", line, at);
}

static void lexer_init(lexer_state *lexer) {
  lexer->content_start = 0;
  lexer->content_end = 0;
  lexer->content_len = 0;
  lexer->docstring_content_type_start = 0;
  lexer->docstring_content_type_end = 0;
  lexer->mark = 0;
  lexer->keyword_start = 0;
  lexer->keyword_end = 0;
  lexer->next_keyword_start = 0;
  lexer->line_number = 1;
  lexer->last_newline = 0;
  lexer->final_newline = 0;
  lexer->start_col = 0;
}

static VALUE CLexer_alloc(VALUE klass)
{
  VALUE obj;
  lexer_state *lxr = ALLOC(lexer_state);
  lexer_init(lxr);

  obj = Data_Wrap_Struct(klass, NULL, -1, lxr);

  return obj;
}

static VALUE CLexer_init(VALUE self, VALUE listener)
{
  lexer_state *lxr; 
  rb_iv_set(self, "@listener", listener);
  
  lxr = NULL;
  DATA_GET(self, lexer_state, lxr);
  lexer_init(lxr);
  
  return self;
}

static VALUE CLexer_scan(VALUE self, VALUE input)
{
  VALUE input_copy;
  char *data;
  size_t len;
  VALUE listener = rb_iv_get(self, "@listener");

  lexer_state *lexer;
  lexer = NULL;
  DATA_GET(self, lexer_state, lexer);

  input_copy = rb_str_dup(input);

  rb_str_append(input_copy, rb_str_new2("\n%_FEATURE_END_%"));
  data = RSTRING_PTR(input_copy);
  len = RSTRING_LEN(input_copy);
  
  if (len == 0) { 
    rb_raise(rb_eGherkinLexingError, "No content to lex.");
  } else {

    const char *p, *pe, *eof;
    int cs = 0;
    
    VALUE current_row = Qnil;

    p = data;
    pe = data + len;
    eof = pe;
    
    assert(*pe == '\0' && "pointer does not end on NULL");
    
    
#line 1715 "ext/gherkin_lexer_sr_cyrl/gherkin_lexer_sr_cyrl.c"
	{
	cs = lexer_start;
	}

#line 425 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
    
#line 1722 "ext/gherkin_lexer_sr_cyrl/gherkin_lexer_sr_cyrl.c"
	{
	int _klen;
	unsigned int _trans;
	const char *_acts;
	unsigned int _nacts;
	const char *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_keys = _lexer_trans_keys + _lexer_key_offsets[cs];
	_trans = _lexer_index_offsets[cs];

	_klen = _lexer_single_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _lexer_range_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += ((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	cs = _lexer_trans_targs[_trans];

	if ( _lexer_trans_actions[_trans] == 0 )
		goto _again;

	_acts = _lexer_actions + _lexer_trans_actions[_trans];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 )
	{
		switch ( *_acts++ )
		{
	case 0:
#line 83 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
		MARK(content_start, p);
    lexer->current_line = lexer->line_number;
    lexer->start_col = lexer->content_start - lexer->last_newline - (lexer->keyword_end - lexer->keyword_start) + 2;
  }
	break;
	case 1:
#line 89 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    MARK(content_start, p);
  }
	break;
	case 2:
#line 93 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    lexer->current_line = lexer->line_number;
    lexer->start_col = p - data - lexer->last_newline;
  }
	break;
	case 3:
#line 98 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    int len = LEN(content_start, PTR_TO(final_newline));
    int type_len = LEN(docstring_content_type_start, PTR_TO(docstring_content_type_end));

    if (len < 0) len = 0;
    if (type_len < 0) len = 0;

    store_docstring_content(listener, lexer->start_col, PTR_TO(docstring_content_type_start), type_len, PTR_TO(content_start), len, lexer->current_line);
  }
	break;
	case 4:
#line 108 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{ 
    MARK(docstring_content_type_start, p);
  }
	break;
	case 5:
#line 112 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{ 
    MARK(docstring_content_type_end, p);
  }
	break;
	case 6:
#line 116 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    STORE_KW_END_CON(feature);
  }
	break;
	case 7:
#line 120 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    STORE_KW_END_CON(background);
  }
	break;
	case 8:
#line 124 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    STORE_KW_END_CON(scenario);
  }
	break;
	case 9:
#line 128 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    STORE_KW_END_CON(scenario_outline);
  }
	break;
	case 10:
#line 132 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    STORE_KW_END_CON(examples);
  }
	break;
	case 11:
#line 136 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    store_kw_con(listener, "step",
      PTR_TO(keyword_start), LEN(keyword_start, PTR_TO(keyword_end)),
      PTR_TO(content_start), LEN(content_start, p), 
      lexer->current_line);
  }
	break;
	case 12:
#line 143 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    STORE_ATTR(comment);
    lexer->mark = 0;
  }
	break;
	case 13:
#line 148 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    STORE_ATTR(tag);
    lexer->mark = 0;
  }
	break;
	case 14:
#line 153 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    lexer->line_number += 1;
    MARK(final_newline, p);
  }
	break;
	case 15:
#line 158 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    MARK(last_newline, p + 1);
  }
	break;
	case 16:
#line 162 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    if (lexer->mark == 0) {
      MARK(mark, p);
    }
  }
	break;
	case 17:
#line 168 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    MARK(keyword_end, p);
    MARK(keyword_start, PTR_TO(mark));
    MARK(content_start, p + 1);
    lexer->mark = 0;
  }
	break;
	case 18:
#line 175 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    MARK(content_end, p);
  }
	break;
	case 19:
#line 179 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    p = p - 1;
    lexer->current_line = lexer->line_number;
    current_row = rb_ary_new();
  }
	break;
	case 20:
#line 185 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
		MARK(content_start, p);
  }
	break;
	case 21:
#line 189 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    VALUE re_pipe, re_newline, re_backslash;
    VALUE con = ENCODED_STR_NEW(PTR_TO(content_start), LEN(content_start, p));
    rb_funcall(con, rb_intern("strip!"), 0);
    re_pipe      = rb_reg_regcomp(rb_str_new2("\\\\\\|"));
    re_newline   = rb_reg_regcomp(rb_str_new2("\\\\n"));
    re_backslash = rb_reg_regcomp(rb_str_new2("\\\\\\\\"));
    rb_funcall(con, rb_intern("gsub!"), 2, re_pipe,      rb_str_new2("|"));
    rb_funcall(con, rb_intern("gsub!"), 2, re_newline,   rb_str_new2("\n"));
    rb_funcall(con, rb_intern("gsub!"), 2, re_backslash, rb_str_new2("\\"));

    rb_ary_push(current_row, con);
  }
	break;
	case 22:
#line 203 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    rb_funcall(listener, rb_intern("row"), 2, current_row, INT2FIX(lexer->current_line));
  }
	break;
	case 23:
#line 207 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    int line;
    if (cs < lexer_first_final) {
      size_t count = 0;
      VALUE newstr_val;
      char *newstr;
      int newstr_count = 0;        
      size_t len;
      const char *buff;
      if (lexer->last_newline != 0) {
        len = LEN(last_newline, eof);
        buff = PTR_TO(last_newline);
      } else {
        len = strlen(data);
        buff = data;
      }

      // Allocate as a ruby string so that it gets cleaned up by GC
      newstr_val = rb_str_new(buff, len);
      newstr = RSTRING_PTR(newstr_val);


      for (count = 0; count < len; count++) {
        if(buff[count] == 10) {
          newstr[newstr_count] = '\0'; // terminate new string at first newline found
          break;
        } else {
          if (buff[count] == '%') {
            newstr[newstr_count++] = buff[count];
            newstr[newstr_count] = buff[count];
          } else {
            newstr[newstr_count] = buff[count];
          }
        }
        newstr_count++;
      }

      line = lexer->line_number;
      lexer_init(lexer); // Re-initialize so we can scan again with the same lexer
      raise_lexer_error(newstr, line);
    } else {
      rb_funcall(listener, rb_intern("eof"), 0);
    }
  }
	break;
#line 2012 "ext/gherkin_lexer_sr_cyrl/gherkin_lexer_sr_cyrl.c"
		}
	}

_again:
	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	if ( p == eof )
	{
	const char *__acts = _lexer_actions + _lexer_eof_actions[cs];
	unsigned int __nacts = (unsigned int) *__acts++;
	while ( __nacts-- > 0 ) {
		switch ( *__acts++ ) {
	case 23:
#line 207 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"
	{
    int line;
    if (cs < lexer_first_final) {
      size_t count = 0;
      VALUE newstr_val;
      char *newstr;
      int newstr_count = 0;        
      size_t len;
      const char *buff;
      if (lexer->last_newline != 0) {
        len = LEN(last_newline, eof);
        buff = PTR_TO(last_newline);
      } else {
        len = strlen(data);
        buff = data;
      }

      // Allocate as a ruby string so that it gets cleaned up by GC
      newstr_val = rb_str_new(buff, len);
      newstr = RSTRING_PTR(newstr_val);


      for (count = 0; count < len; count++) {
        if(buff[count] == 10) {
          newstr[newstr_count] = '\0'; // terminate new string at first newline found
          break;
        } else {
          if (buff[count] == '%') {
            newstr[newstr_count++] = buff[count];
            newstr[newstr_count] = buff[count];
          } else {
            newstr[newstr_count] = buff[count];
          }
        }
        newstr_count++;
      }

      line = lexer->line_number;
      lexer_init(lexer); // Re-initialize so we can scan again with the same lexer
      raise_lexer_error(newstr, line);
    } else {
      rb_funcall(listener, rb_intern("eof"), 0);
    }
  }
	break;
#line 2075 "ext/gherkin_lexer_sr_cyrl/gherkin_lexer_sr_cyrl.c"
		}
	}
	}

	_out: {}
	}

#line 426 "/Users/ahellesoy/scm/gherkin/tasks/../ragel/i18n/sr_cyrl.c.rl"

    assert(p <= pe && "data overflow after parsing execute");
    assert(lexer->content_start <= len && "content starts after data end");
    assert(lexer->mark < len && "mark is after data end");
    
    // Reset lexer by re-initializing the whole thing
    lexer_init(lexer);

    if (cs == lexer_error) {
      rb_raise(rb_eGherkinLexingError, "Invalid format, lexing fails.");
    } else {
      return Qtrue;
    }
  }
}

void Init_gherkin_lexer_sr_cyrl()
{
  mGherkin = rb_define_module("Gherkin");
  mGherkinLexer = rb_define_module_under(mGherkin, "Lexer");
  rb_eGherkinLexingError = rb_const_get(mGherkinLexer, rb_intern("LexingError"));

  mCLexer = rb_define_module_under(mGherkin, "CLexer");
  cI18nLexer = rb_define_class_under(mCLexer, "Sr_cyrl", rb_cObject);
  rb_define_alloc_func(cI18nLexer, CLexer_alloc);
  rb_define_method(cI18nLexer, "initialize", CLexer_init, 1);
  rb_define_method(cI18nLexer, "scan", CLexer_scan, 1);
}

